﻿# Contrôle et systèmes

## Description de l'équipe

## Organisation des fichiers
- Datasheets
- devBoard_setup
	- Tutorial and blank examples for board A and B
- Standard_robot
	- Code pour un robot standard
- tourelle
	- ROS test

## TODO List
- [ x ] Programmer les dev boards + tutoriel
- [ x ] Faire fonctionner les différents moteurs
- [] Structure générale du code
- [] Compilation et upload du code dans Linux

## Liens utiles

### Githubs

* [Robomaster, General](https://github.com/RoboMaster)
* [RoboMaster_Referee](https://github.com/SyndicateYe/Robomaster_Referee)
* [RoboRTS](https://github.com/RoboMaster/RoboRTS-Firmware/tree/icra2019/bsp)
* [Illini Robomaster](https://github.com/illini-robomaster)
* [Purdue](https://github.com/RoboMaster-Club)
* [UBC](https://github.com/ubcrobomaster)

### Sites des équipes
* [Virginia Tech](https://github.com/SyndicateYe/Robomaster_Referee)
* [Purdue](https://purduerm.com/)

### Tutorials
* [RobotRTS, quickstart](https://robomaster.github.io/RoboRTS-Tutorial/#/en/roborts)
* [Infantry Setup, UBC](https://docs.google.com/document/d/19cvIZilfux3r4_W7IBOViRhD_JSUb53r_CtSJ3eYy1E/edit)

### Set up du ESC C610 et M2006
* Set up manuel: 
	a. In the normal working state of the ESC, press the SET button for a short time to enter the independent setting ID mode.
	 At this time, the indicator light is off.
	b. In the independent setting ID mode, short press the SET button (no more than 8 times) is the set ID number. Each
	 Press briefly, the indicator light flashes once.
	c. If the SET button is not operated for 3 seconds, the ESC will automatically save the current setting ID number. ESC needs to set ID 
	 Duplicate IDs cannot occur on the same bus, otherwise ESCs with conflicting IDs will warn and close the output
* Set up automatique:
	a. Under normal working conditions, short press the SET button of any C610 ESC on the bus once to enter the independent mode.
	 After the ID setting mode, press and hold the SET button again. At this time, all ESCs on the bus will enter the quick setting ID mode.
	 The ESC indicator is solid orange.
	b. Manually rotate the rotor of the M2006 motor corresponding to the C610 ESC in turn according to the preset ID (rotate at least in any direction)
	 More than half a circle), the ESC will automatically start numbering from 1 in turn according to the rotation order, the numbered ESCs need to be 
	 powered on again.
	 Can enter normal working conditions. 
* Calibration:
	 After the ESC motor is connected and powered on, the user calibrates the motor's position sensor parameters to ensure that the motor can
	 Enough to work normally, the specific operation is as follows:
	a. Press and hold the SET button until the indicator light flashes green quickly and release the SET button.
	b. The motor enters the automatic calibration mode, and it will automatically exit the calibration mode after the calibration is completed. 

* Procédure du CAN:
CAN communication protocol

1. ESC receive message format
	Used to send a control instruction to the ESC to control the ESC's current output. The two identifiers (0x200 and 0x1FF) correspond
	Control ESC for 4 IDs. Control torque current value range -10000 ~ 0 ~ 10000, corresponding to the torque current of ESC output

	The range is -10 ~ 0 ~ 10A.
	Identifier: 0x200 Frame format: DATA
	Frame type: Standard frame DLC: 8 bytes

	Data field	content					ESC ID
	DATA [0]	8-bit higher control current value	1
	DATA [1]	8-bit lower control current value	1

	DATA [2]	8-bit higher control current value	2
	DATA [3]	8-bit lower control current value	2

	DATA [4]	8-bit higher control current value	3
	DATA [5]	8-bit lower control current value	3

	DATA [6]	8-bit higher control current value	4
	DATA [7]	8-bit lower control current value	4

	Identifier: 0x1FF Frame format: DATA
	Frame type: Standard frame DLC: 8 bytes

	Data field	content					ESC ID
	DATA [0]	8-bit higher control current value	5
	DATA [1]	8-bit lower control current value	5

	DATA [2]	8-bit higher control current value	6
	DATA [3]	8-bit lower control current value	6

	DATA [4]	8-bit higher control current value	7
	DATA [5]	8-bit lower control current value	7

	DATA [6]	8-bit higher control current value	8
	DATA [7]	8-bit lower control current value	8

2. ESC feedback message format
	The feedback data sent by the ESC to the bus.
	Identifier: 0x200 + ESC ID (eg: ID is 1, this identifier is 0x201)
	Frame format: DATA
	Frame type: standard frame
	DLC: 8 bytes 

	Data field	content
	DATA [0]	8-bit higher rotor mechanical angle
	DATA [1]	8-bit lower mechanical rotor angle

	DATA [2]	8-bit higher rotor speed
	DATA [3]	8 digits lower rotor speed

	DATA [4]	8 digits higher actual output torque
	DATA [5]	8 digits lower actual output torque

	DATA [6]	Null
	DATA [7]	Null 

